import 'package:carousel_slider/carousel_slider.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:get/get.dart';
import 'package:worker_client/models/entities/Banner.dart';
import 'package:worker_client/models/entities/Job.dart';
import 'package:worker_client/pages/home/widgets/home/widgets/headers.dart';
import 'package:worker_client/services/banner.dart';
import 'package:worker_client/services/job.dart';
import 'package:worker_client/widgets/MoreList.dart';
import 'package:worker_client/widgets/MyCard/index.dart';

class HomePage extends StatefulWidget {
  const HomePage({Key? key}) : super(key: key);

  @override
  State<HomePage> createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  final bannerList = Rx<List<BannerModel>>([]);
  List<Job> jobList = [];
  final job = Rx<Job>(Job());
  @override
  void initState() {
    super.initState();
    getBannerList('bannerWorker').then((res) {
      List<BannerModel> list = [];
      for (var item in res) {
        list.add(BannerModel.fromJson(item));
      }
      bannerList.value = list;
    });
  }

  List<Job> GetList(value) {
    List<Job> list = [];
    value.forEach((item) => {list.add(Job.fromJson(item))});
    return list;
  }

  Map<String, dynamic> map = {'pageNum': 1};

  void changeJob(Job item) {}
  void goDetail(Job item) {
    Get.toNamed('/detail', arguments: {'id': item.jobId});
  }

  @override
  Widget build(BuildContext context) {
    return MoreList(
      serves: getJobList,
      params: map,
      getJson: (BuildContext context, List<dynamic> jsonData) {
        jobList = GetList(jsonData);
        return Column(
          children: [
            Container(
              decoration: const BoxDecoration(color: Colors.white),
              padding: EdgeInsets.all(15.w),
              child: Column(
                children: [
                  const headers(),
                  //banner
                  Container(
                    margin: EdgeInsets.fromLTRB(0, 15.h, 0, 15.h),
                    child: Obx(() => CarouselSlider(
                          items: bannerList.value
                              .map((item) => Container(
                                    child: Center(
                                        child: Image.network(
                                            item.thumb.toString(),
                                            fit: BoxFit.cover,
                                            width: 345.w)),
                                  ))
                              .toList(),
                          options: CarouselOptions(
                            autoPlay: true,
                            enlargeCenterPage: false,
                            //图片中心放大
                            viewportFraction: 1,
                            //每个页面应占据的视口部分。默认为 0.8，这意味着每个页面填充 80% 的轮播。
                            // aspectRatio: 1.6,//纵横比
                            height: 214.w,
                            initialPage: 1, //初始页
                          ),
                        )),
                  ),
                  Container(
                    margin: EdgeInsets.fromLTRB(0, 15.h, 0, 20.h),
                    child: Row(
                      children: [
                        Padding(
                          padding: EdgeInsets.fromLTRB(0, 0, 10.w, 0),
                          child: Image.asset(
                            'images/index/orderList.png',
                            width: 20.w,
                          ),
                        ),
                        Text(
                          '作业列表',
                          style: TextStyle(
                              color: Color(0xff222222),
                              fontSize: 20.sp,
                              fontWeight: FontWeight.w800),
                        )
                      ],
                    ),
                  ),
                  Column(
                    children: jobList
                        .map(
                          (item) => MyCard(
                            item: item,
                            job: true,
                            detail: false,
                            onClick: () {
                              changeJob(item);
                            },
                            goDetail: () {
                              goDetail(item);
                            },
                            buttomText: item.status == 0 ? '开始作业' : '完成作业',
                          ),
                        )
                        .toList(),
                  ),
                ],
              ),
            ),
          ],
        );
      },
    );
  }
}
